--
-- upgrade_beta1_beta12.sql
-- 
-- Upgrade einer WASKA beta1 Datenbank auf WASKA beta12:
-- - CREATE FUNCTION waska_revoke_connect()
-- - REPLACE FUNCTION waska_drop_role()
BEGIN;

-- CREATE PROCEDURAL LANGUAGE plpgsql;

SET search_path = public, pg_catalog;

--
-- isEditorOrStandin(integer)
-- Liefert TRUE wenn der Benutzer fr die Fallakte 
-- a) Bearbeiter oder
-- b) Vertreter ist
-- Sonst FALSE
--
CREATE OR REPLACE FUNCTION isEditorOrStandin(mid integer)
RETURNS bool 
    LANGUAGE 'plpgsql' STABLE
    AS $$
DECLARE
bid integer;
isAllowed integer;
BEGIN
SELECT bearbeiter_id into bid from master_tbl_view WHERE id = mid;
IF bid = getuserid() THEN
RETURN TRUE;
ELSE 
SELECT INTO isAllowed benutzer_id FROM 
	nm_benutzer_master_tbl_view WHERE 
	master_id = mid AND benutzer_id = getuserid() ;
END IF;
RETURN FOUND;
END;
$$;

REVOKE ALL ON FUNCTION isEditorOrStandin( integer ) FROM public;
GRANT EXECUTE ON FUNCTION isEditorOrStandin(integer) TO GROUP :cm_ka_group;
GRANT EXECUTE ON FUNCTION isEditorOrStandin(integer) TO GROUP :admin_ka_group;
ALTER FUNCTION isEditorOrStandin( integer ) OWNER TO :db_adm;

COMMIT;
