BEGIN;
--
-- Erweiterung der Unterstuetzungsangebote um den Bereich Zielvereinbarung.
--
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
        VALUES ('update_1_0_4/01_zielvereinbarung.sql', current_timestamp);

CREATE TABLE bewertung_manager_1_tbl (
	id SERIAL PRIMARY KEY NOT NULL,
	value VARCHAR(15) NOT NULL
 );

INSERT INTO bewertung_manager_1_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO bewertung_manager_1_tbl (id, value) VALUES (0, 'nicht erreicht');
INSERT INTO bewertung_manager_1_tbl (id, value) VALUES (1, 'erreicht');

 GRANT SELECT ON bewertung_manager_1_tbl TO GROUP :cm_ka_group;
 GRANT SELECT ON bewertung_manager_1_tbl TO GROUP :admin_ka_group;


ALTER TABLE rg_angebote_bildenden_bereich_tbl
	ADD COLUMN zielsetzungangebot VARCHAR(60),
	ADD COLUMN indikator_1 VARCHAR(60),
	ADD COLUMN bewertung_manager_1 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_1 INTEGER DEFAULT -1,
	ADD COLUMN indikator_2 VARCHAR(60),
	ADD COLUMN bewertung_manager_2 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_2 INTEGER DEFAULT -1,
	ADD COLUMN indikator_3 VARCHAR(60),
	ADD COLUMN bewertung_manager_3 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_3 INTEGER DEFAULT -1,
	ADD COLUMN zielerreichung TEXT;

ALTER TABLE rg_angebote_bildenden_bereich_tbl
	ADD CONSTRAINT rg_angebote_bildenden_bereich_tbl_bewertung_manager_1_fkey FOREIGN KEY (bewertung_manager_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_bildenden_bereich_tbl_bewertung_jugendlicher_1_fkey FOREIGN KEY (bewertung_jugendlicher_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_bildenden_bereich_tbl_bewertung_manager_2_fkey FOREIGN KEY (bewertung_manager_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_bildenden_bereich_tbl_bewertung_jugendlicher_2_fkey FOREIGN KEY (bewertung_jugendlicher_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_bildenden_bereich_tbl_bewertung_manager_3_fkey FOREIGN KEY (bewertung_manager_3) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_bildenden_bereich_tbl_bewertung_jugendlicher_3_fkey FOREIGN KEY (bewertung_jugendlicher_3) REFERENCES bewertung_manager_1_tbl (id);

ALTER TABLE rg_angebote_berufsvorbereitung_tbl
	ADD COLUMN zielsetzungangebot VARCHAR(60),
	ADD COLUMN indikator_1 VARCHAR(60),
	ADD COLUMN bewertung_manager_1 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_1 INTEGER DEFAULT -1,
	ADD COLUMN indikator_2 VARCHAR(60),
	ADD COLUMN bewertung_manager_2 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_2 INTEGER DEFAULT -1,
	ADD COLUMN indikator_3 VARCHAR(60),
	ADD COLUMN bewertung_manager_3 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_3 INTEGER DEFAULT -1,
	ADD COLUMN zielerreichung TEXT;

ALTER TABLE rg_angebote_berufsvorbereitung_tbl
	ADD CONSTRAINT rg_angebote_berufsvorbereitung_tbl_bewertung_manager_1_fkey FOREIGN KEY (bewertung_manager_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufsvorbereitung_tb_bewertung_jugendlicher_1_fkey FOREIGN KEY (bewertung_jugendlicher_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufsvorbereitung_tbl_bewertung_manager_2_fkey FOREIGN KEY (bewertung_manager_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufsvorbereitung_tb_bewertung_jugendlicher_2_fkey FOREIGN KEY (bewertung_jugendlicher_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufsvorbereitung_tbl_bewertung_manager_3_fkey FOREIGN KEY (bewertung_manager_3) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufsvorbereitung_tb_bewertung_jugendlicher_3_fkey FOREIGN KEY (bewertung_jugendlicher_3) REFERENCES bewertung_manager_1_tbl (id);

ALTER TABLE rg_angebote_berufliche_qualifizierung_tbl
	ADD COLUMN zielsetzungangebot VARCHAR(60),
	ADD COLUMN indikator_1 VARCHAR(60),
	ADD COLUMN bewertung_manager_1 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_1 INTEGER DEFAULT -1,
	ADD COLUMN indikator_2 VARCHAR(60),
	ADD COLUMN bewertung_manager_2 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_2 INTEGER DEFAULT -1,
	ADD COLUMN indikator_3 VARCHAR(60),
	ADD COLUMN bewertung_manager_3 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_3 INTEGER DEFAULT -1,
	ADD COLUMN zielerreichung TEXT;

ALTER TABLE rg_angebote_berufliche_qualifizierung_tbl
	ADD CONSTRAINT rg_angebote_berufliche_qualifizierung__bewertung_manager_1_fkey FOREIGN KEY (bewertung_manager_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufliche_qualifizie_bewertung_jugendlicher_1_fkey FOREIGN KEY (bewertung_jugendlicher_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufliche_qualifizierung__bewertung_manager_2_fkey FOREIGN KEY (bewertung_manager_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufliche_qualifizie_bewertung_jugendlicher_2_fkey FOREIGN KEY (bewertung_jugendlicher_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufliche_qualifizierung__bewertung_manager_3_fkey FOREIGN KEY (bewertung_manager_3) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_berufliche_qualifizie_bewertung_jugendlicher_3_fkey FOREIGN KEY (bewertung_jugendlicher_3) REFERENCES bewertung_manager_1_tbl (id);

ALTER TABLE rg_angebote_lebensbewaeltigung_tbl
	ADD COLUMN zielsetzungangebot VARCHAR(60),
	ADD COLUMN indikator_1 VARCHAR(60),
	ADD COLUMN bewertung_manager_1 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_1 INTEGER DEFAULT -1,
	ADD COLUMN indikator_2 VARCHAR(60),
	ADD COLUMN bewertung_manager_2 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_2 INTEGER DEFAULT -1,
	ADD COLUMN indikator_3 VARCHAR(60),
	ADD COLUMN bewertung_manager_3 INTEGER DEFAULT -1,
	ADD COLUMN bewertung_jugendlicher_3 INTEGER DEFAULT -1,
	ADD COLUMN zielerreichung TEXT;

ALTER TABLE rg_angebote_lebensbewaeltigung_tbl
	ADD CONSTRAINT rg_angebote_lebensbewaeltigung_tbl_bewertung_manager_1_fkey FOREIGN KEY (bewertung_manager_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_lebensbewaeltigung_tb_bewertung_jugendlicher_1_fkey FOREIGN KEY (bewertung_jugendlicher_1) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_lebensbewaeltigung_tbl_bewertung_manager_2_fkey FOREIGN KEY (bewertung_manager_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_lebensbewaeltigung_tb_bewertung_jugendlicher_2_fkey FOREIGN KEY (bewertung_jugendlicher_2) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_lebensbewaeltigung_tbl_bewertung_manager_3_fkey FOREIGN KEY (bewertung_manager_3) REFERENCES bewertung_manager_1_tbl (id),
	ADD CONSTRAINT rg_angebote_lebensbewaeltigung_tb_bewertung_jugendlicher_3_fkey FOREIGN KEY (bewertung_jugendlicher_3) REFERENCES bewertung_manager_1_tbl (id);

-- Austauschen der Views
DROP VIEW page_21_view CASCADE;
DROP VIEW page_22_view CASCADE;
DROP VIEW page_23_view CASCADE;
DROP VIEW page_24_view CASCADE;
DROP VIEW rg_angebote_bildenden_bereich_tbl_view CASCADE;
DROP VIEW rg_angebote_berufsvorbereitung_tbl_view CASCADE;
DROP VIEW rg_angebote_lebensbewaeltigung_tbl_view CASCADE;
DROP VIEW rg_angebote_berufliche_qualifizierung_tbl_view CASCADE;

CREATE OR REPLACE VIEW rg_angebote_bildenden_bereich_tbl_view
AS SELECT rg_angebote_bildenden_bereich_tbl.* FROM rg_angebote_bildenden_bereich_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_bildenden_bereich_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_update_rule AS ON UPDATE TO rg_angebote_bildenden_bereich_tbl_view
DO INSTEAD UPDATE rg_angebote_bildenden_bereich_tbl SET
    angebotsform = NEW.angebotsform,
    art_der_unterstuetzung = NEW.art_der_unterstuetzung,
    durchfuehrende_institution = NEW.durchfuehrende_institution,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start = NEW.unterstuetzung_start,
    unterstuetzung_ende = NEW.unterstuetzung_ende,
    zeitlicher_umfang_unterstuetzung = NEW.zeitlicher_umfang_unterstuetzung,
    beendigung_1 = NEW.beendigung_1,
    beendigung_durch = NEW.beendigung_durch,
    gruende_vorzeitige_beendigung = NEW.gruende_vorzeitige_beendigung,
    gruende_sonstiges_nennung = NEW.gruende_sonstiges_nennung,
    nachweis_bescheinigung = NEW.nachweis_bescheinigung,
    sonstiges_nachweis_bescheinigung = NEW.sonstiges_nachweis_bescheinigung
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_delete_rule AS ON DELETE TO rg_angebote_bildenden_bereich_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_insert_rule AS ON INSERT TO rg_angebote_bildenden_bereich_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_bildenden_bereich_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_bildenden_bereich_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_bildenden_bereich_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_bildenden_bereich_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    angebotsform,
    art_der_unterstuetzung,
    durchfuehrende_institution,
    zielsetzungangebot,
    indikator_1,
    bewertung_manager_1,
    bewertung_jugendlicher_1,
    indikator_2,
    bewertung_manager_2,
    bewertung_jugendlicher_2,
    indikator_3,
    bewertung_manager_3,
    bewertung_jugendlicher_3,
    zielerreichung,
    unterstuetzung_start,
    unterstuetzung_ende,
    zeitlicher_umfang_unterstuetzung,
    beendigung_1,
    beendigung_durch,
    gruende_vorzeitige_beendigung,
    gruende_sonstiges_nennung,
    nachweis_bescheinigung,
    sonstiges_nachweis_bescheinigung FROM rg_angebote_bildenden_bereich_tbl_view;

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_anonym_delete_rule AS ON DELETE TO rg_angebote_bildenden_bereich_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_anonym_insert_rule AS ON INSERT TO rg_angebote_bildenden_bereich_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_bildenden_bereich_tbl_anonym_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_bildenden_bereich_tbl_anonym_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_berufsvorbereitung_tbl_view
AS SELECT rg_angebote_berufsvorbereitung_tbl.* FROM rg_angebote_berufsvorbereitung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_berufsvorbereitung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_update_rule AS ON UPDATE TO rg_angebote_berufsvorbereitung_tbl_view
DO INSTEAD UPDATE rg_angebote_berufsvorbereitung_tbl SET
    angebotsform_1 = NEW.angebotsform_1,
    art_der_unterstuetzung_1 = NEW.art_der_unterstuetzung_1,
    unterstuetzung_sonstiges_nennung = NEW.unterstuetzung_sonstiges_nennung,
    durchfuehrende_institution_1 = NEW.durchfuehrende_institution_1,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start_1 = NEW.unterstuetzung_start_1,
    unterstuetzung_ende_1 = NEW.unterstuetzung_ende_1,
    zeitlicher_umfang_unterstuetzung_1 = NEW.zeitlicher_umfang_unterstuetzung_1,
    beendigung_2 = NEW.beendigung_2,
    beendigung_durch_1 = NEW.beendigung_durch_1,
    gruende_vorzeitige_beendigung_1 = NEW.gruende_vorzeitige_beendigung_1,
    gruende_sonstiges_nennung_1 = NEW.gruende_sonstiges_nennung_1,
    nachweis_bescheinigung_1 = NEW.nachweis_bescheinigung_1,
    sonstiges_nachweis_bescheinigung_1 = NEW.sonstiges_nachweis_bescheinigung_1
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_delete_rule AS ON DELETE TO rg_angebote_berufsvorbereitung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_insert_rule AS ON INSERT TO rg_angebote_berufsvorbereitung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_berufsvorbereitung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_berufsvorbereitung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_berufsvorbereitung_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_berufsvorbereitung_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    angebotsform_1,
    art_der_unterstuetzung_1,
    unterstuetzung_sonstiges_nennung,
    durchfuehrende_institution_1,
    zielsetzungangebot,
    indikator_1,
    bewertung_manager_1,
    bewertung_jugendlicher_1,
    indikator_2,
    bewertung_manager_2,
    bewertung_jugendlicher_2,
    indikator_3,
    bewertung_manager_3,
    bewertung_jugendlicher_3,
    zielerreichung,
    unterstuetzung_start_1,
    unterstuetzung_ende_1,
    zeitlicher_umfang_unterstuetzung_1,
    beendigung_2,
    beendigung_durch_1,
    gruende_vorzeitige_beendigung_1,
    gruende_sonstiges_nennung_1,
    nachweis_bescheinigung_1,
    sonstiges_nachweis_bescheinigung_1 FROM rg_angebote_berufsvorbereitung_tbl_view;

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_anonym_delete_rule AS ON DELETE TO rg_angebote_berufsvorbereitung_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_anonym_insert_rule AS ON INSERT TO rg_angebote_berufsvorbereitung_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_berufsvorbereitung_tbl_anonym_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_berufsvorbereitung_tbl_anonym_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_berufliche_qualifizierung_tbl_view
AS SELECT rg_angebote_berufliche_qualifizierung_tbl.* FROM rg_angebote_berufliche_qualifizierung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_berufliche_qualifizierung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_update_rule AS ON UPDATE TO rg_angebote_berufliche_qualifizierung_tbl_view
DO INSTEAD UPDATE rg_angebote_berufliche_qualifizierung_tbl SET
    angebotsform_2 = NEW.angebotsform_2,
    angebote_im_bereich = NEW.angebote_im_bereich,
    unterstuetzung_sonstiges_nennung_1 = NEW.unterstuetzung_sonstiges_nennung_1,
    durchfuehrende_institution_2 = NEW.durchfuehrende_institution_2,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start_2 = NEW.unterstuetzung_start_2,
    unterstuetzung_ende_2 = NEW.unterstuetzung_ende_2,
    zeitlicher_umfang_unterstuetzung_2 = NEW.zeitlicher_umfang_unterstuetzung_2,
    beendigung_3 = NEW.beendigung_3,
    beendigung_durch_2 = NEW.beendigung_durch_2,
    gruende_vorzeitige_beendigung_2 = NEW.gruende_vorzeitige_beendigung_2,
    gruende_sonstiges_nennung_2 = NEW.gruende_sonstiges_nennung_2,
    nachweis_bescheinigung_2 = NEW.nachweis_bescheinigung_2,
    sonstiges_nachweis_bescheinigung_2 = NEW.sonstiges_nachweis_bescheinigung_2
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_delete_rule AS ON DELETE TO rg_angebote_berufliche_qualifizierung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_insert_rule AS ON INSERT TO rg_angebote_berufliche_qualifizierung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_berufliche_qualifizierung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_berufliche_qualifizierung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_berufliche_qualifizierung_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_berufliche_qualifizierung_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    angebotsform_2,
    angebote_im_bereich,
    unterstuetzung_sonstiges_nennung_1,
    durchfuehrende_institution_2,
    zielsetzungangebot,
    indikator_1,
    bewertung_manager_1,
    bewertung_jugendlicher_1,
    indikator_2,
    bewertung_manager_2,
    bewertung_jugendlicher_2,
    indikator_3,
    bewertung_manager_3,
    bewertung_jugendlicher_3,
    zielerreichung,
    unterstuetzung_start_2,
    unterstuetzung_ende_2,
    zeitlicher_umfang_unterstuetzung_2,
    beendigung_3,
    beendigung_durch_2,
    gruende_vorzeitige_beendigung_2,
    gruende_sonstiges_nennung_2,
    nachweis_bescheinigung_2,
    sonstiges_nachweis_bescheinigung_2 FROM rg_angebote_berufliche_qualifizierung_tbl_view;

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_anonym_delete_rule AS ON DELETE TO rg_angebote_berufliche_qualifizierung_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_anonym_insert_rule AS ON INSERT TO rg_angebote_berufliche_qualifizierung_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_berufliche_qualifizierung_tbl_anonym_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_berufliche_qualifizierung_tbl_anonym_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_lebensbewaeltigung_tbl_view
AS SELECT rg_angebote_lebensbewaeltigung_tbl.* FROM rg_angebote_lebensbewaeltigung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_lebensbewaeltigung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_update_rule AS ON UPDATE TO rg_angebote_lebensbewaeltigung_tbl_view
DO INSTEAD UPDATE rg_angebote_lebensbewaeltigung_tbl SET
    angebotsform_3 = NEW.angebotsform_3,
    unterstuetzung_angebotsform_sonstiges_nennung = NEW.unterstuetzung_angebotsform_sonstiges_nennung,
    art_der_unterstuetzung_2 = NEW.art_der_unterstuetzung_2,
    unterstuetzung_sonstiges_nennung_2 = NEW.unterstuetzung_sonstiges_nennung_2,
    durchfuehrende_institution_3 = NEW.durchfuehrende_institution_3,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start_3 = NEW.unterstuetzung_start_3,
    unterstuetzung_ende_3 = NEW.unterstuetzung_ende_3,
    zeitlicher_umfang_unterstuetzung_3 = NEW.zeitlicher_umfang_unterstuetzung_3,
    beendigung_4 = NEW.beendigung_4,
    beendigung_durch_3 = NEW.beendigung_durch_3,
    gruende_vorzeitige_beendigung_3 = NEW.gruende_vorzeitige_beendigung_3,
    gruende_sonstiges_nennung_3 = NEW.gruende_sonstiges_nennung_3,
    nachweis_bescheinigung_3 = NEW.nachweis_bescheinigung_3,
    sonstiges_nachweis_bescheinigung_3 = NEW.sonstiges_nachweis_bescheinigung_3
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_delete_rule AS ON DELETE TO rg_angebote_lebensbewaeltigung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_insert_rule AS ON INSERT TO rg_angebote_lebensbewaeltigung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_lebensbewaeltigung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_lebensbewaeltigung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_lebensbewaeltigung_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_lebensbewaeltigung_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    angebotsform_3,
    unterstuetzung_angebotsform_sonstiges_nennung,
    art_der_unterstuetzung_2,
    unterstuetzung_sonstiges_nennung_2,
    durchfuehrende_institution_3,
    zielsetzungangebot,
    indikator_1,
    bewertung_manager_1,
    bewertung_jugendlicher_1,
    indikator_2,
    bewertung_manager_2,
    bewertung_jugendlicher_2,
    indikator_3,
    bewertung_manager_3,
    bewertung_jugendlicher_3,
    zielerreichung,
    unterstuetzung_start_3,
    unterstuetzung_ende_3,
    zeitlicher_umfang_unterstuetzung_3,
    beendigung_4,
    beendigung_durch_3,
    gruende_vorzeitige_beendigung_3,
    gruende_sonstiges_nennung_3,
    nachweis_bescheinigung_3,
    sonstiges_nachweis_bescheinigung_3 FROM rg_angebote_lebensbewaeltigung_tbl_view;

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_anonym_delete_rule AS ON DELETE TO rg_angebote_lebensbewaeltigung_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_anonym_insert_rule AS ON INSERT TO rg_angebote_lebensbewaeltigung_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_lebensbewaeltigung_tbl_anonym_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_lebensbewaeltigung_tbl_anonym_view TO GROUP :admin_ka_group;


CREATE OR REPLACE VIEW page_21_view AS SELECT
    rg_angebote_bildenden_bereich_tbl.id AS id,
    rg_angebote_bildenden_bereich_tbl.angebotsform AS angebotsform,
    rg_angebote_bildenden_bereich_tbl.art_der_unterstuetzung AS art_der_unterstuetzung,
    rg_angebote_bildenden_bereich_tbl.durchfuehrende_institution AS durchfuehrende_institution,
    rg_angebote_bildenden_bereich_tbl.zielsetzungangebot AS zielsetzungangebot,
    rg_angebote_bildenden_bereich_tbl.indikator_1 AS indikator_1,
    rg_angebote_bildenden_bereich_tbl.bewertung_manager_1 AS bewertung_manager_1,
    rg_angebote_bildenden_bereich_tbl.bewertung_jugendlicher_1 AS bewertung_jugendlicher_1,
    rg_angebote_bildenden_bereich_tbl.indikator_2 AS indikator_2,
    rg_angebote_bildenden_bereich_tbl.bewertung_manager_2 AS bewertung_manager_2,
    rg_angebote_bildenden_bereich_tbl.bewertung_jugendlicher_2 AS bewertung_jugendlicher_2,
    rg_angebote_bildenden_bereich_tbl.indikator_3 AS indikator_3,
    rg_angebote_bildenden_bereich_tbl.bewertung_manager_3 AS bewertung_manager_3,
    rg_angebote_bildenden_bereich_tbl.bewertung_jugendlicher_3 AS bewertung_jugendlicher_3,
    rg_angebote_bildenden_bereich_tbl.zielerreichung AS zielerreichung,
    rg_angebote_bildenden_bereich_tbl.unterstuetzung_start AS unterstuetzung_start,
    rg_angebote_bildenden_bereich_tbl.unterstuetzung_ende AS unterstuetzung_ende,
    rg_angebote_bildenden_bereich_tbl.zeitlicher_umfang_unterstuetzung AS zeitlicher_umfang_unterstuetzung,
    rg_angebote_bildenden_bereich_tbl.beendigung_1 AS beendigung_1,
    rg_angebote_bildenden_bereich_tbl.beendigung_durch AS beendigung_durch,
    rg_angebote_bildenden_bereich_tbl.gruende_vorzeitige_beendigung AS gruende_vorzeitige_beendigung,
    rg_angebote_bildenden_bereich_tbl.gruende_sonstiges_nennung AS gruende_sonstiges_nennung,
    rg_angebote_bildenden_bereich_tbl.nachweis_bescheinigung AS nachweis_bescheinigung,
    rg_angebote_bildenden_bereich_tbl.sonstiges_nachweis_bescheinigung AS sonstiges_nachweis_bescheinigung
FROM rg_angebote_bildenden_bereich_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_bildenden_bereich_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE page_21_update_rule AS ON UPDATE TO page_21_view
DO INSTEAD UPDATE rg_angebote_bildenden_bereich_tbl SET
    angebotsform = NEW.angebotsform,
    art_der_unterstuetzung = NEW.art_der_unterstuetzung,
    durchfuehrende_institution = NEW.durchfuehrende_institution,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start = NEW.unterstuetzung_start,
    unterstuetzung_ende = NEW.unterstuetzung_ende,
    zeitlicher_umfang_unterstuetzung = NEW.zeitlicher_umfang_unterstuetzung,
    beendigung_1 = NEW.beendigung_1,
    beendigung_durch = NEW.beendigung_durch,
    gruende_vorzeitige_beendigung = NEW.gruende_vorzeitige_beendigung,
    gruende_sonstiges_nennung = NEW.gruende_sonstiges_nennung,
    nachweis_bescheinigung = NEW.nachweis_bescheinigung,
    sonstiges_nachweis_bescheinigung = NEW.sonstiges_nachweis_bescheinigung
WHERE id = NEW.id;

GRANT SELECT ON page_21_view TO GROUP :cm_ka_group;
GRANT UPDATE ON page_21_view TO GROUP :cm_ka_group;
GRANT SELECT ON page_21_view TO GROUP :admin_ka_group;

CREATE OR REPLACE RULE page_21_delete_rule AS ON DELETE TO page_21_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE page_21_insert_rule AS ON INSERT TO page_21_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE VIEW page_22_view AS SELECT
    rg_angebote_berufsvorbereitung_tbl.id AS id,
    rg_angebote_berufsvorbereitung_tbl.angebotsform_1 AS angebotsform_1,
    rg_angebote_berufsvorbereitung_tbl.art_der_unterstuetzung_1 AS art_der_unterstuetzung_1,
    rg_angebote_berufsvorbereitung_tbl.unterstuetzung_sonstiges_nennung AS unterstuetzung_sonstiges_nennung,
    rg_angebote_berufsvorbereitung_tbl.durchfuehrende_institution_1 AS durchfuehrende_institution_1,
    rg_angebote_berufsvorbereitung_tbl.zielsetzungangebot AS zielsetzungangebot,
    rg_angebote_berufsvorbereitung_tbl.indikator_1 AS indikator_1,
    rg_angebote_berufsvorbereitung_tbl.bewertung_manager_1 AS bewertung_manager_1,
    rg_angebote_berufsvorbereitung_tbl.bewertung_jugendlicher_1 AS bewertung_jugendlicher_1,
    rg_angebote_berufsvorbereitung_tbl.indikator_2 AS indikator_2,
    rg_angebote_berufsvorbereitung_tbl.bewertung_manager_2 AS bewertung_manager_2,
    rg_angebote_berufsvorbereitung_tbl.bewertung_jugendlicher_2 AS bewertung_jugendlicher_2,
    rg_angebote_berufsvorbereitung_tbl.indikator_3 AS indikator_3,
    rg_angebote_berufsvorbereitung_tbl.bewertung_manager_3 AS bewertung_manager_3,
    rg_angebote_berufsvorbereitung_tbl.bewertung_jugendlicher_3 AS bewertung_jugendlicher_3,
    rg_angebote_berufsvorbereitung_tbl.zielerreichung AS zielerreichung,
    rg_angebote_berufsvorbereitung_tbl.unterstuetzung_start_1 AS unterstuetzung_start_1,
    rg_angebote_berufsvorbereitung_tbl.unterstuetzung_ende_1 AS unterstuetzung_ende_1,
    rg_angebote_berufsvorbereitung_tbl.zeitlicher_umfang_unterstuetzung_1 AS zeitlicher_umfang_unterstuetzung_1,
    rg_angebote_berufsvorbereitung_tbl.beendigung_2 AS beendigung_2,
    rg_angebote_berufsvorbereitung_tbl.beendigung_durch_1 AS beendigung_durch_1,
    rg_angebote_berufsvorbereitung_tbl.gruende_vorzeitige_beendigung_1 AS gruende_vorzeitige_beendigung_1,
    rg_angebote_berufsvorbereitung_tbl.gruende_sonstiges_nennung_1 AS gruende_sonstiges_nennung_1,
    rg_angebote_berufsvorbereitung_tbl.nachweis_bescheinigung_1 AS nachweis_bescheinigung_1,
    rg_angebote_berufsvorbereitung_tbl.sonstiges_nachweis_bescheinigung_1 AS sonstiges_nachweis_bescheinigung_1
FROM rg_angebote_berufsvorbereitung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_berufsvorbereitung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE page_22_update_rule AS ON UPDATE TO page_22_view
DO INSTEAD UPDATE rg_angebote_berufsvorbereitung_tbl SET
    angebotsform_1 = NEW.angebotsform_1,
    art_der_unterstuetzung_1 = NEW.art_der_unterstuetzung_1,
    unterstuetzung_sonstiges_nennung = NEW.unterstuetzung_sonstiges_nennung,
    durchfuehrende_institution_1 = NEW.durchfuehrende_institution_1,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start_1 = NEW.unterstuetzung_start_1,
    unterstuetzung_ende_1 = NEW.unterstuetzung_ende_1,
    zeitlicher_umfang_unterstuetzung_1 = NEW.zeitlicher_umfang_unterstuetzung_1,
    beendigung_2 = NEW.beendigung_2,
    beendigung_durch_1 = NEW.beendigung_durch_1,
    gruende_vorzeitige_beendigung_1 = NEW.gruende_vorzeitige_beendigung_1,
    gruende_sonstiges_nennung_1 = NEW.gruende_sonstiges_nennung_1,
    nachweis_bescheinigung_1 = NEW.nachweis_bescheinigung_1,
    sonstiges_nachweis_bescheinigung_1 = NEW.sonstiges_nachweis_bescheinigung_1
WHERE id = NEW.id;

GRANT SELECT ON page_22_view TO GROUP :cm_ka_group;
GRANT UPDATE ON page_22_view TO GROUP :cm_ka_group;
GRANT SELECT ON page_22_view TO GROUP :admin_ka_group;

CREATE OR REPLACE RULE page_22_delete_rule AS ON DELETE TO page_22_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE page_22_insert_rule AS ON INSERT TO page_22_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE VIEW page_23_view AS SELECT
    rg_angebote_berufliche_qualifizierung_tbl.id AS id,
    rg_angebote_berufliche_qualifizierung_tbl.angebotsform_2 AS angebotsform_2,
    rg_angebote_berufliche_qualifizierung_tbl.angebote_im_bereich AS angebote_im_bereich,
    rg_angebote_berufliche_qualifizierung_tbl.unterstuetzung_sonstiges_nennung_1 AS unterstuetzung_sonstiges_nennung_1,
    rg_angebote_berufliche_qualifizierung_tbl.durchfuehrende_institution_2 AS durchfuehrende_institution_2,
    rg_angebote_berufliche_qualifizierung_tbl.zielsetzungangebot AS zielsetzungangebot,
    rg_angebote_berufliche_qualifizierung_tbl.indikator_1 AS indikator_1,
    rg_angebote_berufliche_qualifizierung_tbl.bewertung_manager_1 AS bewertung_manager_1,
    rg_angebote_berufliche_qualifizierung_tbl.bewertung_jugendlicher_1 AS bewertung_jugendlicher_1,
    rg_angebote_berufliche_qualifizierung_tbl.indikator_2 AS indikator_2,
    rg_angebote_berufliche_qualifizierung_tbl.bewertung_manager_2 AS bewertung_manager_2,
    rg_angebote_berufliche_qualifizierung_tbl.bewertung_jugendlicher_2 AS bewertung_jugendlicher_2,
    rg_angebote_berufliche_qualifizierung_tbl.indikator_3 AS indikator_3,
    rg_angebote_berufliche_qualifizierung_tbl.bewertung_manager_3 AS bewertung_manager_3,
    rg_angebote_berufliche_qualifizierung_tbl.bewertung_jugendlicher_3 AS bewertung_jugendlicher_3,
    rg_angebote_berufliche_qualifizierung_tbl.zielerreichung AS zielerreichung,
    rg_angebote_berufliche_qualifizierung_tbl.unterstuetzung_start_2 AS unterstuetzung_start_2,
    rg_angebote_berufliche_qualifizierung_tbl.unterstuetzung_ende_2 AS unterstuetzung_ende_2,
    rg_angebote_berufliche_qualifizierung_tbl.zeitlicher_umfang_unterstuetzung_2 AS zeitlicher_umfang_unterstuetzung_2,
    rg_angebote_berufliche_qualifizierung_tbl.beendigung_3 AS beendigung_3,
    rg_angebote_berufliche_qualifizierung_tbl.beendigung_durch_2 AS beendigung_durch_2,
    rg_angebote_berufliche_qualifizierung_tbl.gruende_vorzeitige_beendigung_2 AS gruende_vorzeitige_beendigung_2,
    rg_angebote_berufliche_qualifizierung_tbl.gruende_sonstiges_nennung_2 AS gruende_sonstiges_nennung_2,
    rg_angebote_berufliche_qualifizierung_tbl.nachweis_bescheinigung_2 AS nachweis_bescheinigung_2,
    rg_angebote_berufliche_qualifizierung_tbl.sonstiges_nachweis_bescheinigung_2 AS sonstiges_nachweis_bescheinigung_2
FROM rg_angebote_berufliche_qualifizierung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_berufliche_qualifizierung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE page_23_update_rule AS ON UPDATE TO page_23_view
DO INSTEAD UPDATE rg_angebote_berufliche_qualifizierung_tbl SET
    angebotsform_2 = NEW.angebotsform_2,
    angebote_im_bereich = NEW.angebote_im_bereich,
    unterstuetzung_sonstiges_nennung_1 = NEW.unterstuetzung_sonstiges_nennung_1,
    durchfuehrende_institution_2 = NEW.durchfuehrende_institution_2,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start_2 = NEW.unterstuetzung_start_2,
    unterstuetzung_ende_2 = NEW.unterstuetzung_ende_2,
    zeitlicher_umfang_unterstuetzung_2 = NEW.zeitlicher_umfang_unterstuetzung_2,
    beendigung_3 = NEW.beendigung_3,
    beendigung_durch_2 = NEW.beendigung_durch_2,
    gruende_vorzeitige_beendigung_2 = NEW.gruende_vorzeitige_beendigung_2,
    gruende_sonstiges_nennung_2 = NEW.gruende_sonstiges_nennung_2,
    nachweis_bescheinigung_2 = NEW.nachweis_bescheinigung_2,
    sonstiges_nachweis_bescheinigung_2 = NEW.sonstiges_nachweis_bescheinigung_2
WHERE id = NEW.id;

GRANT SELECT ON page_23_view TO GROUP :cm_ka_group;
GRANT UPDATE ON page_23_view TO GROUP :cm_ka_group;
GRANT SELECT ON page_23_view TO GROUP :admin_ka_group;

CREATE OR REPLACE RULE page_23_delete_rule AS ON DELETE TO page_23_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE page_23_insert_rule AS ON INSERT TO page_23_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE VIEW page_24_view AS SELECT
    rg_angebote_lebensbewaeltigung_tbl.id AS id,
    rg_angebote_lebensbewaeltigung_tbl.angebotsform_3 AS angebotsform_3,
    rg_angebote_lebensbewaeltigung_tbl.unterstuetzung_angebotsform_sonstiges_nennung AS unterstuetzung_angebotsform_sonstiges_nennung,
    rg_angebote_lebensbewaeltigung_tbl.art_der_unterstuetzung_2 AS art_der_unterstuetzung_2,
    rg_angebote_lebensbewaeltigung_tbl.unterstuetzung_sonstiges_nennung_2 AS unterstuetzung_sonstiges_nennung_2,
    rg_angebote_lebensbewaeltigung_tbl.durchfuehrende_institution_3 AS durchfuehrende_institution_3,
    rg_angebote_lebensbewaeltigung_tbl.zielsetzungangebot AS zielsetzungangebot,
    rg_angebote_lebensbewaeltigung_tbl.indikator_1 AS indikator_1,
    rg_angebote_lebensbewaeltigung_tbl.bewertung_manager_1 AS bewertung_manager_1,
    rg_angebote_lebensbewaeltigung_tbl.bewertung_jugendlicher_1 AS bewertung_jugendlicher_1,
    rg_angebote_lebensbewaeltigung_tbl.indikator_2 AS indikator_2,
    rg_angebote_lebensbewaeltigung_tbl.bewertung_manager_2 AS bewertung_manager_2,
    rg_angebote_lebensbewaeltigung_tbl.bewertung_jugendlicher_2 AS bewertung_jugendlicher_2,
    rg_angebote_lebensbewaeltigung_tbl.indikator_3 AS indikator_3,
    rg_angebote_lebensbewaeltigung_tbl.bewertung_manager_3 AS bewertung_manager_3,
    rg_angebote_lebensbewaeltigung_tbl.bewertung_jugendlicher_3 AS bewertung_jugendlicher_3,
    rg_angebote_lebensbewaeltigung_tbl.zielerreichung AS zielerreichung,
    rg_angebote_lebensbewaeltigung_tbl.unterstuetzung_start_3 AS unterstuetzung_start_3,
    rg_angebote_lebensbewaeltigung_tbl.unterstuetzung_ende_3 AS unterstuetzung_ende_3,
    rg_angebote_lebensbewaeltigung_tbl.zeitlicher_umfang_unterstuetzung_3 AS zeitlicher_umfang_unterstuetzung_3,
    rg_angebote_lebensbewaeltigung_tbl.beendigung_4 AS beendigung_4,
    rg_angebote_lebensbewaeltigung_tbl.beendigung_durch_3 AS beendigung_durch_3,
    rg_angebote_lebensbewaeltigung_tbl.gruende_vorzeitige_beendigung_3 AS gruende_vorzeitige_beendigung_3,
    rg_angebote_lebensbewaeltigung_tbl.gruende_sonstiges_nennung_3 AS gruende_sonstiges_nennung_3,
    rg_angebote_lebensbewaeltigung_tbl.nachweis_bescheinigung_3 AS nachweis_bescheinigung_3,
    rg_angebote_lebensbewaeltigung_tbl.sonstiges_nachweis_bescheinigung_3 AS sonstiges_nachweis_bescheinigung_3
FROM rg_angebote_lebensbewaeltigung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_lebensbewaeltigung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE page_24_update_rule AS ON UPDATE TO page_24_view
DO INSTEAD UPDATE rg_angebote_lebensbewaeltigung_tbl SET
    angebotsform_3 = NEW.angebotsform_3,
    unterstuetzung_angebotsform_sonstiges_nennung = NEW.unterstuetzung_angebotsform_sonstiges_nennung,
    art_der_unterstuetzung_2 = NEW.art_der_unterstuetzung_2,
    unterstuetzung_sonstiges_nennung_2 = NEW.unterstuetzung_sonstiges_nennung_2,
    durchfuehrende_institution_3 = NEW.durchfuehrende_institution_3,
    zielsetzungangebot = NEW.zielsetzungangebot,
    indikator_1 = NEW.indikator_1,
    bewertung_manager_1 = NEW.bewertung_manager_1,
    bewertung_jugendlicher_1 = NEW.bewertung_jugendlicher_1,
    indikator_2 = NEW.indikator_2,
    bewertung_manager_2 = NEW.bewertung_manager_2,
    bewertung_jugendlicher_2 = NEW.bewertung_jugendlicher_2,
    indikator_3 = NEW.indikator_3,
    bewertung_manager_3 = NEW.bewertung_manager_3,
    bewertung_jugendlicher_3 = NEW.bewertung_jugendlicher_3,
    zielerreichung = NEW.zielerreichung,
    unterstuetzung_start_3 = NEW.unterstuetzung_start_3,
    unterstuetzung_ende_3 = NEW.unterstuetzung_ende_3,
    zeitlicher_umfang_unterstuetzung_3 = NEW.zeitlicher_umfang_unterstuetzung_3,
    beendigung_4 = NEW.beendigung_4,
    beendigung_durch_3 = NEW.beendigung_durch_3,
    gruende_vorzeitige_beendigung_3 = NEW.gruende_vorzeitige_beendigung_3,
    gruende_sonstiges_nennung_3 = NEW.gruende_sonstiges_nennung_3,
    nachweis_bescheinigung_3 = NEW.nachweis_bescheinigung_3,
    sonstiges_nachweis_bescheinigung_3 = NEW.sonstiges_nachweis_bescheinigung_3
WHERE id = NEW.id;

GRANT SELECT ON page_24_view TO GROUP :cm_ka_group;
GRANT UPDATE ON page_24_view TO GROUP :cm_ka_group;
GRANT SELECT ON page_24_view TO GROUP :admin_ka_group;

CREATE OR REPLACE RULE page_24_delete_rule AS ON DELETE TO page_24_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE page_24_insert_rule AS ON INSERT TO page_24_view
    DO INSTEAD NOTHING;

COMMIT;
