-- This script os only needed if there are databases which are already updated wich an
-- old version of akte_zustande.sql.
-- But it should be no problem to run this script anyway.


-- Funktionen zum Anlegen neuer (Teile von) Fallakten
-- Diese sind nur für die Gruppe CM_KA aufrufbar (Admin_KA darf keine neuen 
-- Akten anlegen) und laufen mit den Berechtigungen des zentralen
-- administrativen Benutzers der KA
CREATE OR REPLACE FUNCTION create_master_ds() RETURNS integer
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
    AS $$
DECLARE
    standin integer;
BEGIN
INSERT INTO master_tbl (bearbeiter_id) VALUES (getuserid());
SELECT INTO standin vertreter from ka_benutzer_tbl WHERE id = getuserid();
IF standin IS NOT NULL THEN 
    INSERT INTO nm_benutzer_master_tbl(benutzer_id, master_id) VALUES (standin, 
currval('master_tbl_id_seq'));
END IF;
PERFORM create_status_ds(CAST (currval('master_tbl_id_seq') AS integer));
RETURN currval('master_tbl_id_seq');
END;
$$ ;

--
-- create_status_ds(mid integer)
-- legt einen statusdatensatz für eine Fallakte an
-- 
-- deletion of the entry is done by ON DELETE CONSTRAINT

CREATE OR REPLACE FUNCTION create_status_ds(mid integer)
RETURNS VOID 
    LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER 
    AS $$
BEGIN
INSERT INTO ka_status_tbl (master_id, zugriff, status) VALUES (mid, now(), 1);
END;
$$;

REVOKE ALL ON FUNCTION create_status_ds( integer ) FROM public;
GRANT EXECUTE ON FUNCTION create_status_ds(integer) TO GROUP :cm_ka_group;
ALTER FUNCTION create_status_ds( integer ) OWNER TO :db_adm;
