--
-- Dies Funktion 'delete_old_anonymized_cases' loescht alle anonymisierten 
-- Fallakten, die laenger als die Aufbewahrungsfrist der jeweiligen KA
-- unbearbeitet im System liegen.
--
BEGIN;
SET ROLE :db_adm;

CREATE OR REPLACE FUNCTION delete_old_anonymized_cases()
RETURNS void AS
$$
DECLARE
    mid          int;
    max_age      interval;
    max_age_text text;
BEGIN
    SELECT INTO max_age_text wert FROM ka_konfiguration_tbl_view WHERE bez = 'max_speicherdauer';
    IF NOT FOUND
    THEN
        RETURN;
    END IF;

    max_age = (max_age_text || ' day')::interval;

    FOR mid IN SELECT m.id FROM master_tbl_view m
               JOIN ka_status_tbl_view s
               ON m.id = s.master_id
               WHERE
               s.status = 5 AND age(s.zugriff) >= max_age
    LOOP
        PERFORM delete_master_ds(mid);
    END LOOP;
END;
$$ LANGUAGE plpgsql;

REVOKE ALL    ON FUNCTION delete_old_anonymized_cases() FROM public;
GRANT EXECUTE ON FUNCTION delete_old_anonymized_cases() TO GROUP :admin_ka_group;

COMMIT;
